######################################################################
#
# WebMail, a IMAP/POP Webmail product for Zope
#
# This software is governed by a license. See 
# LICENSE.txt for the terms of this license.
#
######################################################################

__version__='v4.1'

from IMAPPasserelle import *
from POPPasserelle import *
from IMAPFolder import *
from IMAPMessage import *
from Attachement import *



import timeoutsocket, smtplib
from base64 import encodestring, decodestring

timeoutsocket.setDefaultSocketTimeout(20) # 10 seconds de timeout 

from Globals import HTMLFile
from types import *
from RFC822MessagesTools import *
from urllib import quote, unquote
from Globals import Persistent
from DateTime import *
from OFS.SimpleItem import Item
from Globals import DTMLFile
from AccessControl import ClassSecurityInfo

import Acquisition, AccessControl.Role, OFS, random, string

try:
    from Products.PTKBase.Document import *
except:
    pass

from Translation import *

#manage_add_WebMail_form=HTMLFile('dtml/manage_add_WebMail_form', globals())


def manage_add_Wmail2(self, id='WebMailv2_0', title='Wmail', REQUEST=None, RESPONSE=None):
    """Add a instance of the WebMail class"""

    try:
        wmail = WebMail(id)
        wmail.title=title
        self._setObject(id, wmail)
    except:
        id=str(random.randrange(1,999))+"WebMail"
        wmail = WebMail(id)
        wmail.title=title
        self._setObject(id, wmail)

    if REQUEST is not None:
        RESPONSE.redirect(self.absolute_url() + '/' + id +"/language_choice")


def manage_add_WebMail(self,
                       id='WebMailv2_0', title='',
                       mailFrom = '', nomFrom = '',
                       login = '',password = '',
                       IMAPHost = '',IMAPPort = '',
                       SMTPHost = '', SMTPPort ='',
                       REQUEST=None, RESPONSE=None
                       ):
    """Add a instance of the WebMail class"""
    wmail = WebMail(id)
    
    wmail.title = title
    if mailFrom:
        wmail.mailFrom = mailFrom
    if login:
        wmail.login = login
    if password:
        wmail.password = password
    if nomFrom:
        wmail.nomFrom = nomFrom
    if IMAPHost:
        wmail.IMAPHost = IMAPHost
    if IMAPPort:
        wmail.IMAPPort = IMAPPort
    if SMTPHost:
        wmail.SMTPHost = SMTPHost
    if SMTPPort:
        wmail.SMTPPort = SMTPPort


    self._setObject(id, wmail)

    if REQUEST is not None:
        RESPONSE.redirect(self.absolute_url() + '/' + id)


class WebMail(Translation,Item,Persistent,
              Acquisition.Implicit,
              AccessControl.Role.RoleManager
              ):
    """ WebMail object """
    meta_type = 'WebMail'

    security = ClassSecurityInfo()

    manage = manage_main = HTMLFile('dtml/WebMailManage',globals())
    manage_main._setName('manage_main')

    ################################
    ## Configuration
    ## You can change those values
    

    use_webmail_cookie  = 0   # if 1 we do not store password in, we use a cookie
    default_protocol    = "IMAP"
    default_smtp_server = ""
    default_mail_server = "" 

    ##
    ##
    #################################

    manage_options=(
        (
        {'icon':'', 'label':'Edit',
         'action':'manage_main', 'target':'manage_main',
         'help':('','')},
        {'icon':'', 'label':'View',
         'action':'index_html', 'target':'manage_main',
         'help':('','')}
        )
        +AccessControl.Role.RoleManager.manage_options
        +OFS.SimpleItem.Item.manage_options
        )



    localHeader  = HTMLFile('standard_html_header',globals())
    localFooter = HTMLFile('standard_html_footer',globals())

    #standard_html_header = localHeader
    #standard_html_footer = localFooter

    css_style_header = HTMLFile('css_style_header',globals())

    ##################################################
    #### Style Sheets
    ##################################################
    
    wMailStyle1 = HTMLFile('style_sheet/webMailStyle1',globals())
    wMailStyle2 = HTMLFile('style_sheet/webMailStyle2',globals())
    wMailStyle3 = HTMLFile('style_sheet/webMailStyle3',globals())
    wMailStyle4 = HTMLFile('style_sheet/iceandsunstyle',globals())
    wMailStyle5 = HTMLFile('style_sheet/icestyle',globals())
    wMailStyle6 = HTMLFile('style_sheet/sunstyle',globals())

    ##################################################
    #### DTML pages
    ##################################################

    language_choice_dtml = HTMLFile('dtml/first_step_install', globals())
    view_folder = HTMLFile('dtml/view_folder',globals())
    view_message_dtml = HTMLFile('dtml/view_message',globals())
    edit_message_dtml = HTMLFile('dtml/edit_message',globals())
    add_attachement = HTMLFile('dtml/add_attachement',globals())
    editOption = HTMLFile('dtml/editOption',globals())
    editConfiguration_dtml = HTMLFile('dtml/editConfiguration',globals())
    search = HTMLFile('dtml/search',globals())
    confirme_delete_folder = HTMLFile('dtml/confirme_delete_folder',globals())
    create_folder = HTMLFile('dtml/create_folder',globals())
    view_printable_message_dtml = HTMLFile('dtml/view_printable_message',globals())
    view_message_source_dtml = HTMLFile('dtml/view_message_source',globals())
    view_error_dtml = HTMLFile('dtml/view_error',globals())

    mailBook_dtml = HTMLFile('dtml/mailBook', globals())


    ##################################################
    ##### Pics
    ##################################################

    icon = 'misc_/WebMail/icon_mail.gif'
    image_folder = 'misc_/WebMail/folder.gif'
    image_flag = 'misc_/WebMail/flag.gif'
    image_composer = 'misc_/WebMail/composer.gif'
    image_messageLu = 'misc_/WebMail/messageLu.gif'
    image_messageRep = 'misc_/WebMail/messageRep.gif'
    image_retirer = 'misc_/WebMail/retirer.gif'
    image_supprimer = 'misc_/WebMail/supprimer.gif'
    image_creerDossier = 'misc_/WebMail/creerDossier.gif'
    image_messageNonLu = 'misc_/WebMail/messageNonLu.gif'
    image_options = 'misc_/WebMail/options.gif'
    image_soulignmail = 'misc_/WebMail/soulignmail.gif'
    image_wmaillogo = 'misc_/WebMail/wmaillogo.gif'
    image_trombone = 'misc_/WebMail/trombone.gif'
    image_cacheTrombone = 'misc_/WebMail/cacheTrombone.gif'
    image_repondre = 'misc_/WebMail/repondre.gif'
    image_repondreTous = 'misc_/WebMail/repondreTous.gif'
    image_faireSuivre = 'misc_/WebMail/faireSuivre.gif'
    image_messageRep = 'misc_/WebMail/messageRep.gif'
    image_imprimanteMail = 'misc_/WebMail/imprimanteMail.gif'
    image_composerPetit= 'misc_/WebMail/composerPetit.gif'
    image_poubelle= 'misc_/WebMail/poubelle.gif'




    def update_params(self, REQUEST):
        """ update connection and login params """

        if REQUEST.mailFrom != self.getMailFrom():
            self.mailFrom = REQUEST.mailFrom
        if REQUEST.login != self.getIMAPLogin():
            self.login = REQUEST.login
        if self.use_webmail_cookie == 0:
            if REQUEST.password != self.getIMAPPassword() :
                self.password = REQUEST.password
        else:
            if REQUEST.has_key('password'):
                REQUEST.set('imap_login',self.login)
                REQUEST.set('imap_password',REQUEST.password)
                self.setIMAPCookie(REQUEST,REQUEST.RESPONSE)

        # Traitement des nouveau parametres IMAP folder
        new_dico = {}
        new_dico['INBOX']=[REQUEST['inbox_value'],REQUEST['inbox_label']]
        new_dico['draft']=[REQUEST['draft_value'],REQUEST['draft_label']]
        new_dico['trash']=[REQUEST['trash_value'],REQUEST['trash_label']]
        new_dico['sent-mail']=[REQUEST['sentmail_value'],REQUEST['sentmail_label']]
        if new_dico!=self.getDefaultFoldersNames():
            self.defaultFoldersNames = new_dico
        
        if REQUEST.nomFrom != self.getNomFrom():
            self.nomFrom = REQUEST.nomFrom
        if REQUEST.IMAPHost != self.getIMAPServer():
            self.IMAPHost = REQUEST.IMAPHost
        if REQUEST.IMAPPort != self.getIMAPPort():
            self.IMAPPort = REQUEST.IMAPPort
        if REQUEST.SMTPHost != self.getSMTPServer():
            self.SMTPHost = REQUEST.SMTPHost
        if REQUEST.SMTPPort != self.getSMTPPort():
            self.SMTPPort = REQUEST.SMTPPort
        if REQUEST.wmail_title != self.title:
            self.title=REQUEST.wmail_title
        if REQUEST.protocol != self.getProtocol():
            self.setProtocol(REQUEST.protocol)
        try:
            #test new params
            con = self.getPasserelle()
       	    try:    
               con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
 	    except:
	    	import traceback
		traceback.print_exc()
		print "connection to your imap server failed"
		print "ensure to provide a valid imap (or pop) server and a valid imap (or pop) port"
		return REQUEST.response.redirect(self.absolute_url() + "/editConfiguration_dtml?params_error=1")
            if con.login(self.getIMAPLogin(), self.getIMAPPassword()) == "LOG_FAILED":
		print "login to imap (or pop) server  with username and password failed"
		print "it's could be due to bad imap (or pop) server host, bad username and or bad password"
                return REQUEST.response.redirect(self.absolute_url() + "/editConfiguration_dtml?params_error=1")
            con.logout()
            
	    try:
               smtp_connection = smtplib.SMTP(self.getSMTPServer())
            except:
		import traceback
		traceback.print_exc()
		print "the smtp connection failed"
		print "it's could be due to a bad smtp server hostname"
	   	return REQUEST.response.redirect(self.absolute_url() + "/editConfiguration_dtml?params_error=1")
	    try: 
	       _recipients=[]
               _recipients.append(self.getMailFrom())
               raw_message="From: webmail_installer <ticeus@chez.com>\nSubject:Test Mail\nTo:" + self.getMailFrom() +"\n\n\n this is an automatic params test configuration"
               smtp_connection.sendmail(self.getMailFrom(), _recipients, raw_message)
               smtp_connection.quit()
	    except:
		import traceback
                traceback.print_exc()
		print "we can't send any mail"
		print "be sure to provide a valid smtp server which accept your zope server to send mail"
            return REQUEST.response.redirect(self.absolute_url() + "/index_html")
        except:
	    import traceback
	    traceback.print_exc()
            return REQUEST.response.redirect(self.absolute_url() + "/editConfiguration_dtml?params_error=1")

    def resetConfiguration(self,REQUEST):
        """
        del user change in configuration
        """
        from Acquisition import aq_base
        if hasattr(aq_base(self),'protocol'):
            delattr(aq_base(self),'protocol')
        if hasattr(aq_base(self),'login'):
            delattr(aq_base(self),'login')
        if hasattr(aq_base(self),'password'):
            delattr(aq_base(self),'password')
        if hasattr(aq_base(self),'mailFrom'):
            delattr(aq_base(self),'mailFrom')
        if hasattr(aq_base(self),'nomFrom'):
            delattr(aq_base(self),'nomFrom')
        if hasattr(aq_base(self),'IMAPHost'):
            delattr(aq_base(self),'IMAPHost')
        if hasattr(aq_base(self),'IMAPPort'):
            delattr(aq_base(self),'IMAPPort')
        if hasattr(aq_base(self),'SMTPHost'):
            delattr(aq_base(self),'SMTPHost')
        if hasattr(aq_base(self),'SMTPPort'):
            delattr(aq_base(self),'SMTPPort')
        self.defaultFoldersNames = {}
                    
        return REQUEST.RESPONSE.redirect(self.absolute_url())

    def getProtocol(self):
        """
        return the protocol of this webmail : by default attribut => IMAP
        this is for compatibility
        """
        if not hasattr(self,'protocol'):
            return self.default_protocol
        else:
            return self.protocol

    def setProtocol(self,protocol):
        """ Set the value of the protocol (POP3/IMAP)"""
        self.protocol = protocol

    def getPasserelle(self):
        """ return the GateAway object of this webmail """
        if self.getProtocol() == 'POP3':
            return POPPasserelle.POPPasserelle()
        else:
            return IMAPPasserelle.IMAPPasserelle()


    def isUsingCookie(self):
        """ """
        return self.use_webmail_cookie

    def encodage(self,t):
        """ """
        new_t = string.replace(encodestring(t),'\n','')
        return new_t

    
    def setIMAPCookie(self,REQUEST,RESPONSE):
        """ set a cookie for imap authentification param """
        if REQUEST.has_key('imap_login'):
            log = REQUEST['imap_login']
        if REQUEST.has_key('imap_password'):
            pas = REQUEST['imap_password']
        if log and pas:
            con = self.getPasserelle()
            con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
            l = con.login(log,pas)
            con.logout()
            if l == "LOG_FAILED":
                return RESPONSE.redirect(self.absolute_url() + '/view_error_dtml?warning=1')
            
            key = self.encodage(log+':'+pas)
	    if hasattr(self,'use_AES') and self.use_AES:
                from urllib import quote
                RESPONSE.setCookie( 'imap_ac', quote(self.encrypt_cookie(key)))
            else:
                RESPONSE.setCookie('imap_ac',key)
        return RESPONSE.redirect(self.absolute_url() + '/portal_contents')

    security.declarePrivate('_getAESKey')
    def _getAESKey(self):
        current_date = DateTime.DateTime().millis()
        lastkey = getattr(self,'_AES_KEY',None)
        if lastkey is None:
            new_key = self.gen_key() # 32 bytes long
            self._AES_KEY=(new_key,current_date)
            return new_key
        else:
            if current_date - lastkey[1] > 86400000:
                new_key = self.gen_key() # 32 bytes long
                self._AES_KEY=(new_key,current_date)
                return new_key
            else:
                return  lastkey[0]



    
    # encode en AES la phrase "value" avec la cl AES_key
    def encrypt_cookie(self, value):
        """ """
	from Crypto.Cipher import AES
        if len(value) > 16 :
            nb_car = 16 - (len(value) % 16)
        else:
            nb_car = 16 - len(value)

        # Il faut que la longueur de phrase  encoder soit un multiple de 16
        if nb_car != 0:
            for i in range(0, nb_car):
                value = value + chr(nb_car)

        cle = AES.new(self._getAESKey(), AES.MODE_ECB)

        return cle.encrypt(value)



    # decode une phrase code en AES
    def decrypt_cookie(self, value):
        """ """
	from Crypto.Cipher import AES
        cle = AES.new(self._getAESKey(), AES.MODE_ECB)
        val_decode = cle.decrypt(value)
        last_car = val_decode[-1:]

        if ord(last_car) in range(1,16):  # on retire les caractres en trop ajouts  l'encodage
            last_car = int(ord(last_car))
            for i in val_decode[0-last_car:]:
                if int(ord(i)) != last_car:
                    return val_decode

            return val_decode[:0-last_car]

        return val_decode
    # SP mod -- end


    def getIMAPLogin(self): 
        """ return IMAP login """
        if self.use_webmail_cookie == 1:
            REQUEST = self.REQUEST
            RESPONSE = REQUEST.RESPONSE
            if REQUEST.has_key('imap_ac'):
	        from urllib import unquote
                if hasattr(self,'use_AES') and self.use_AES:
                   return  string.split(decodestring(self.decrypt_cookie(unquote(REQUEST['imap_ac']))),':',1)[0]
                else:
                   return string.split(decodestring(REQUEST['imap_ac']),':',1)[0]
            else:
                raise  'Redirect', self.absolute_url() + '/view_error_dtml?use_cookie=1'
        try:
            if hasattr(self, 'login'):
                return self.login
            elif self.getAuthenticatedMemberLDAPData(self.mail_login_LDAP_attribut):
                return self.getAuthenticatedMemberLDAPData(self.mail_login_LDAP_attribut)
            else:
                return self.getAuthenticatedMemberName()
        except:
            return ''
        
    def getIMAPPassword(self):
        """ return IMAPPassword """
        if self.use_webmail_cookie == 1:
            REQUEST = self.REQUEST
            RESPONSE = REQUEST.RESPONSE
            if REQUEST.has_key('imap_ac'):
                from urllib import unquote
                if hasattr(self,'use_AES') and self.use_AES:
                   return  string.split(decodestring(self.decrypt_cookie(unquote(REQUEST['imap_ac']))),':',1)[1]
                else:
                   return string.split(decodestring(REQUEST['imap_ac']),':',1)[1]
            else:
                raise  'Redirect', self.absolute_url() + '/view_error_dtml?use_cookie=1'

        try:
            if hasattr(self, 'password'):
                return self.password
            elif self.getAuthenticatedMemberLDAPData(self.mail_password_LDAP_attribut):
                return self.getAuthenticatedMemberLDAPData(self.mail_password_LDAP_attribut)
            else:
                return self.getAuthenticatedMemberPassword()
        except:
            return ''


    def getMailFrom(self):
        """ return mail from """
        try:
            if hasattr(self, 'mailFrom'):
                return self.mailFrom
            elif self.getAuthenticatedMemberLDAPData(self.mail_from_LDAP_attribut):
                return self.getAuthenticatedMemberLDAPData(self.mail_from_LDAP_attribut)
            else:
                return self.getAuthenticatedMemberLDAPData(self.mailLDAPAttribut)
        except:
            return ''


    def getNomFrom(self):
        """ return nom from """
        try:
            if hasattr(self, 'nomFrom'):
                return self.nomFrom
            else:
                return self.getAuthenticatedMemberLDAPData('cn')
        except:
            return ''


    def getDomain(self): 
        """ return the name of the amil server domaine -ie all after @ """ 
 
        return self.mail_domain 


    def getIMAPServer(self):
        """ return the IMAP server name"""
        try:
            if hasattr(self, 'IMAPHost'):
                return self.IMAPHost
            elif hasattr(self,'mail_server_LDAP_attribut_eval') and self.mail_server_LDAP_attribut_eval:
                result = self.Execute(self.mail_server_LDAP_attribut_eval, 1)
                if result and type(result) is type([]):
                    result = result[0]
                return result
            elif self.getAuthenticatedMemberLDAPData(self.mail_server_LDAP_attribut):
                return self.getAuthenticatedMemberLDAPData(self.mail_server_LDAP_attribut)
            else:
                return self.default_mail_server
        except:
            return ''
        
    def getIMAPPort(self):
        """ return the IMAP server port """

        if hasattr(self, 'IMAPPort'):
            return self.IMAPPort
        else:
            return ''

    def getSMTPServer(self):
        """ return the SMTP server name"""
        try:
            if hasattr(self, 'SMTPHost'):
                return self.SMTPHost
            elif hasattr(self,'smtp_server_LDAP_attribut_eval') and self.smtp_server_LDAP_attribut_eval:
                result = self.Execute(self.smtp_server_LDAP_attribut_eval, 1)
                if result and type(result) is type([]):
                    result = result[0]
                return result
            elif self.getAuthenticatedMemberLDAPData(self.smtp_server_LDAP_attribut):
                return self.getAuthenticatedMemberLDAPData(self.smtp_server_LDAP_attribut)
            else:
                return self.default_smtp_server
        except:
            return ''

    def getSMTPPort(self):
        """ return the SMTP server port """

        if hasattr(self, 'SMTPPort'):
            return self.SMTPPort
        else:
            return None

    def getVersion(self):
        """ return the product version"""

        return __version__



    def __init__(self, id, signature="", autoSaveSentMessage=1, nbCharSubject=25,
                 listingSize=15, sortmail="order",mailFrom="",
                 IMAPHost="", IMAPPort="", SMTPHost="", SMTPPort="",
                 mailBook=[], wmailLang="fr", wmailtheme="theme4",
                 defaultFoldersNames = {}):
        """ constructor """

        self.id=id
        self.signature=signature
        self.autoSaveSentMessage=autoSaveSentMessage
        self.nbCharSubject=nbCharSubject
        self.listingSize=listingSize
        self.sortmail=sortmail
        self.mailBook=["Test MailBook,ticeuds@chez.com", "Test MailBook2,ticeuds@chez.com"]
        self.wmailtheme=wmailtheme
        self.wmailLang=wmailLang
        #init multilanguage engine
        self.reload_translations()
        if defaultFoldersNames == {}:
            self.setDefaultFoldersNames()
        else:
            self.setDefaultFoldersNames(defaultFoldersNames)

    def getDefaultFoldersNames(self):
        """ return the good dico for the webmail """
        if hasattr(self,'defaultFoldersNames'):
            return self.defaultFoldersNames
             

    def index_html(self, IMAPName="", start=0, REQUEST=None):
        """ return default page """
        if self.getIMAPServer() =='':
            raise 'Redirect', self.absolute_url() + '/view_error_dtml'
        if IMAPName:
            folder=self.getFolder(IMAPName)
        else:
            folder=self.getInboxFolder()

        return self.view_folder(self, folder=folder, start=start, REQUEST=REQUEST)
    
    portal_contents = index_html

    def language_choice(self):
        """ return the language choice page """

        return self.language_choice_dtml(self)


    def editConfiguration(self):
        """ return params edit page """

        return self.editConfiguration_dtml(self)


    def view_error(self,REQUEST=None,RESPONSE=None):
        """ return error page """

        return self.view_error_dtml(self,REQUEST=REQUEST,RESPONSE=RESPONSE)


    def viewMailBook(self):
        """ return mailBook page """

        return self.mailBook_dtml(self)

    def adPeopleMailBook(self, REQUEST=None, new_contact=None):
        """ delete peolple on MailBook """
        
        try:
            if new_contact is None and (len(REQUEST.mailBookMail)>2):
                contact = string.replace(REQUEST.mailBookName, ",", " ")+","+string.replace(REQUEST.mailBookMail, ",", " ")
            else:
                contact = new_contact
            if contact is not None:
                contact=string.capwords(string.replace(contact, '"', ''))
                tempList=self.mailBook
                tempList.append(contact)
                self.mailBook=tempList
        except:
            pass

        if new_contact is None:
            return self.mailBook_dtml(self)

    def delPeopleMailBook(self, REQUEST):
        """ delete peolple on MailBook """

        try:
            tempList=self.mailBook
            del tempList[tempList.index(unquote(REQUEST.peopleToDelete))]
            self.mailBook=tempList
        except:
            pass
        
        return self.mailBook_dtml(self)
    

    def view_message(self, IMAPName="INBOX", IMAPId="", REQUEST=None):
        """ return the view interface of the message """

        try:
            folder = self.getFolder(IMAPName)
            if not folder:
                folder = self.getFolder('inbox')
                IMAPName="inbox"
            message = folder.getIMAPMessage(IMAPId)
        except:
            return self.view_error()
        
        if message != "DELETED":
            return self.view_message_dtml(self, message=message, IMAPName=IMAPName, REQUEST=REQUEST)
        else:
            return "erreur de retrait du message"
            
    def view_message_source(self, IMAPName="INBOX", IMAPId="", REQUEST=None):
        """ return the view interface of the message """
        folder = self.getFolder(IMAPName)
        message = folder.getRawIMAPMessage(IMAPId)
        if message != "DELETED":
            return self.view_message_source_dtml(self, message=message, IMAPName=IMAPName, REQUEST=REQUEST)
        else:
            return "erreur de retrait du message"

    def setMessageFlagged(self, IMAPName="INBOX", IMAPId="", REQUEST=None):
        """ set on the Flagged IMAP flag """

        con = self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        try:
            if REQUEST.isFlagged=="1":
                con.setFlag(folderName=IMAPName, IMAPId=IMAPId, flag="-flagged")
            else:
                con.setFlag(folderName=IMAPName, IMAPId=IMAPId, flag="+flagged")
        except:
            pass
        con.logout()

        try:
            folder = self.getFolder(IMAPName)
            message = folder.getIMAPMessage(IMAPId)
        except:
            return self.view_error()
        
        if message != "DELETED":
            return self.view_message_dtml(self, message=message, IMAPName=IMAPName, REQUEST=REQUEST)
        else:
            return "erreur de retrait du message"



    def view_printable_message(self, IMAPName="INBOX", IMAPId="", REQUEST=None):
        """ return the view interface of the message """
        
        folder = self.getFolder(IMAPName)
        message = folder.getIMAPMessage(IMAPId)
        if message != "DELETED":
            return self.view_printable_message_dtml(self, message=message, IMAPName=IMAPName, REQUEST=REQUEST)
        else:
            return "erreur de retrait du message"


    def edit_message(self, IMAPName="INBOX", IMAPId="",subject="", body="", destinataires={'to':[], 'cc':[], 'bcc':[]},attachements=[], REQUEST=None):
        """ return the edit interface on this message """
        folder = self.getFolder(IMAPName)
        if IMAPId:
            #edit on forward or reply message
            message = folder.getIMAPMessage(IMAPId)
        else:
            if REQUEST.has_key('mailto'):
                if len(string.split(REQUEST['mailto'],','))==2:
                    mailto = string.split(REQUEST['mailto'],',')
                else:
                    mailto = [REQUEST['mailto']]
                destinataire = {'to':mailto, 'cc':[], 'bcc':[]}

            #edition new message
            message=IMAPMessage.IMAPMessage(IMAPId="", flags=[], expediteur=[], size=0, date="", subject=subject, body=body, destinataires=destinataires, attachements=attachements, headers={})

        return self.edit_message_dtml(self, message=message, IMAPName=IMAPName, REQUEST=REQUEST)


    def createIMAPFolder(self, REQUEST):
        """ create a new folder on IMAP server """

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        res_create=con.createFolder(REQUEST.title)
        con.logout()

        IMAPName=REQUEST.IMAPName

        if res_create!= "NO":
            #creation sucessfull
            return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' + quote(REQUEST.IMAPName))
        else:
            #creation unsucessfull
            return REQUEST.response.redirect(self.absolute_url() + '/create_folder?IMAPName=' + quote(REQUEST.IMAPName) +'&error_name=1')
    
    def deleteIMAPFolders(self, REQUEST=None):
        """ delete a IMAP folder """

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        for folder in REQUEST.IMAPNamesToDelete:
            res_del=con.deleteFolder(wmail=self, name=folder)
        con.logout()

        IMAPName=REQUEST.IMAPName

        return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' + quote(REQUEST.IMAPName))

    def emptyTrash(self, REQUEST=None):
        """ empty trash """

        IMAPName=REQUEST.IMAPName

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        con.selectFolder(self.getTrashFolder().getImapName())
        res=con.connection.uid('SEARCH', 'ALL')
        if res!=[]:
            liste_res=map(int, string.split(res[-1][-1]))
            for IMAPId in liste_res:
                con.setFlag(IMAPId=IMAPId, flag="delete")
        con.expunge()
        con.logout()

        return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' + quote(IMAPName))


    def reply(self, REQUEST=None):
        """ render reply formated message """
        
        folder=self.getFolder(REQUEST.IMAPName)
        message=folder.getIMAPMessage(REQUEST.IMAPId)

        message.setSubject('Re: '+message.getSubject())
        message.setBody('\n> ' + string.join(string.split(message.render_body(message.getBody(), 'html'),'\n'), '\n> ') + '\n\n')

        all=int(REQUEST.all)

        if not all:
            #reply to sender
            message.setTo(message.getExpediteurMail())
            message.setCC([])
        else:
            #reply all
            recipients = message.getExpediteurMail() + ', ' + message.getTo()
            message.setTo(recipients)

        message.attachements=[]

        return self.edit_message_dtml(self, message=message, attReply='yes', redirection_url='reply', IMAPName=REQUEST.IMAPName, REQUEST=REQUEST)
        

    def forward(self, REQUEST):
        """ render forward message """

        folder=self.getFolder(REQUEST.IMAPName)
        message=folder.getIMAPMessage(REQUEST.IMAPId)

        message.setSubject('Fwd: '+message.getSubject())
        message.setDestinataires({'to':[], 'cc':[], 'bcc':[]})

        body="\n\n> Expditeur d'origine: "
        body=body+message.getExpediteurName() + ' ('+message.getExpediteurMail()+') '
        body=body+"\n> Date: "+ RFC822MessagesTools.render_date(message.getDate())+"\n\n"

	new_body = string.split(message.render_body(message.getBody(), 'html'), '\n')
        new_body = '> ' + string.join(new_body, '\n> ')  + ' \n\n'
        new_body = body + new_body
        message.setBody(new_body)

        return self.edit_message_dtml(self, message=message, IMAPName=REQUEST.IMAPName, REQUEST=REQUEST, attForward = 'yes',redirection_url='forward')
    

    def searchMail(self, REQUEST=None):
        """ send search request on imap server """

        flagged="non"
        if REQUEST.has_key('only_flagged'):
            if REQUEST.only_flagged=="oui":
                flagged="oui"

        search_date=REQUEST.search_day + "-" + REQUEST.search_month +"-"+ REQUEST.search_year
        search_line=string.replace(REQUEST.search_line, "&", " ")
        search_line=string.replace(search_line, '"', " ")
        search_line=string.replace(search_line, ";", " ")
        if len(search_line)<1:
            search_line=" "
        search_line=string.replace(search_line, " ", "zz20")
        sortmail="search"+"x2jq"+REQUEST.search_where+"x2jq"+search_line+"x2jq"+REQUEST.search_when+"x2jq"+search_date+"x2jq"+flagged+"x2jqsortx2jq"+"DATE"


        try:
            if int(REQUEST.search_year)>1970 and 1<=int(REQUEST.search_day) and int(REQUEST.search_day)<=31:
                #search line OK
                return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&sortmail=' + sortmail)
            else:
                #error in date (must be > 1970)
                return REQUEST.response.redirect(self.absolute_url()+"/search?erreurDate=1" + '&IMAPName=' + quote(REQUEST.IMAPName))
        except:
            #error in search line (special chars)
            return REQUEST.response.redirect(self.absolute_url()+"/search?erreurLine=1" + '&IMAPName=' + quote(REQUEST.IMAPName))


    def searchAddressBook(self):
        """ search AdressBook product installed """
        try:
            abook=self.getAuthenticatedMemberCartable().objectValues('AddressBook2')[0]
        except:
            abook=None
                    
        if abook is not None:
            return abook
        else:
            try:
                #uncomment line below to search abook
                #abook=self.ZopeFind(self.getAuthenticatedMemberCartable(), obj_metatypes=['AddressBook'], search_sub=4)
                abook=[]
                if abook!=[]:
                    return abook[0][1]
                else:
                    return None
            except:
                return None


    def setSignature(self, signature):
        """ set personal mail signature """

        self.signature=signature

    def getSignature(self):
        """ return personal mail signature """

        return self.signature

    def setAutoSaveSentMessage(self, value):
        """ set AutoSaveSentMessage value for auto save sent-messages, boolean """

        self.autoSaveSentMessage=value

    def getAutoSaveSentMessage(self):
        """ return AutoSaveSentMessage value for auto save sent-messages, boolean """

        return self.autoSaveSentMessage

    def setNbCharSubject(self, value):
        """ set Nb Characters display for message Subject """

        self.nbCharSubject=value

    def getNbCharSubject(self):
        """ return Nb Characters display for message Subject """

        return self.nbCharSubject
        
    def setListingSize(self, value):
        """ set the number of messages diplay on one page view """

        self.listingSize=value

    def getListingSize(self):
     """ return the number of messages diplay on one page view """

     return self.listingSize


    def setAutoViewAtt(self, value):
     """ set the autoViewAtt value, if 1 : auto-view html or pics under message """

     self.autoViewAtt=value
 
    def getAutoViewAtt(self):
     """ return the autoViewAtt value """

     if hasattr(self, 'autoViewAtt'):
         return self.autoViewAtt
     else:
         return 0

    def setTheme(self, value):
        """ set the theme value """
        
        self.wmailtheme=value

    def getTheme(self):
        """ return the string them value """

        if hasattr(self, 'wmailtheme'):
            return self.wmailtheme
        else:
            return "theme1"

 
    def getWMailStyle(self):
        """ return the theme value """

        theme=self.getTheme()
        if theme == "theme1":
            wMailStyle=self.wMailStyle1(self)
        if theme == "theme2":
            wMailStyle=self.wMailStyle2(self)
        if theme == "theme3":
            wMailStyle=self.wMailStyle3(self)
        if theme == "theme4":
            wMailStyle=self.wMailStyle4(self)
        if theme == "theme5":
            wMailStyle=self.wMailStyle5(self)
        if theme == "theme6":
            wMailStyle=self.wMailStyle6(self)

        
        return wMailStyle
    

    def get_language(self):
        """return used language """
        
        if hasattr(self, 'wmailLang'):
            return self.wmailLang
        else:
            return "fr"

    def setLang(self, value):
        """ set wmailLang value"""

        self.wmailLang=value

    def set_language_and_config(self, REQUEST=None, RESPONSE=None):
        """ set language before start install """

        #set language
        self.setLang(REQUEST.wmailLanguage)
        
        #set default folders
        if REQUEST.wmailLanguage != "fr":
            self.get_lang(('common',), REQUEST)
        
        RESPONSE.redirect(self.absolute_url()+'/editConfiguration')
        

    def setOption(self, REQUEST):
        """ update WebMail options """

        try:
            if REQUEST.listingSize != self.getListingSize() and REQUEST.listingSize > 0:
                self.setListingSize(int(REQUEST.listingSize))
            if REQUEST.autoSaveSentMessage != self.getAutoSaveSentMessage():
                self.setAutoSaveSentMessage(REQUEST.autoSaveSentMessage)
            if REQUEST.nbCharSubject != self.getNbCharSubject() and REQUEST.nbCharSubject > 0:
                self.setNbCharSubject(int(REQUEST.nbCharSubject))
            if REQUEST.signature != self.getSignature():
                self.setSignature(REQUEST.signature)
            if REQUEST.autoViewAtt != self.getAutoViewAtt():
                self.setAutoViewAtt(REQUEST.autoViewAtt)
            if REQUEST.wmailtheme != self.getTheme():
                self.setTheme(REQUEST.wmailtheme)
            if REQUEST.wmailLang != self.get_language():
                self.setLang(REQUEST.wmailLang)



            return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)
        except:
            return REQUEST.response.redirect(self.absolute_url() + '/editOption?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)

        

    def setSortMail(self, value, REQUEST=None, RESPONSE=None):
        """ set the sorting for getting mail headers"""
        if value:
            RESPONSE.setCookie('sortmail',value)
        else:
            RESPONSE.expireCookie( 'sortmail')

    def getSortMail(self, REQUEST=None):
        """ return the sorting for getting mail headers"""
        if REQUEST is not None:
            if REQUEST.has_key('sortmail'):
                return REQUEST['sortmail']
        return 'date'

    def getFolderType(self, folderIMAPName):
        """ return the type of the folderIMAPName folder"""
        

    def setConfiguration(self, IMAPServer="", IMAPPort="", SMTPServer="", SMTPPort=""):
        """ set mail servers """

        self.IMAPHost=IMAPHost
        self.IMAPPort=IMAPPort
        self.SMTPHost=SMTPHost
        self.SMTPPort=SMTPPort


    def getFolder(self, IMAPName):
        """ return foder instance """
        
        for f in self.getIMAPFolders():
            if IMAPName==f.getImapName():
                return f

    def getInboxFolder(self):
        """ return the InboxFolder Id"""

        return IMAPFolder(self.getInboxIMAPName(), self.getInboxRdName(), self)

    def getDraftFolder(self):
        """ return the Draft folder Id """
        
        return IMAPFolder(self.getDraftIMAPName(), self.getDraftRdName(), self)

    def getSentMailFolder(self):
        """ return the Sent Mail folder Id """

        return IMAPFolder(self.getSentMailIMAPName(), self.getSentMailRdName(), self)

    def getTrashFolder(self):
        """ return the Trash Folder Id """

        return IMAPFolder(self.getTrashIMAPName(), self.getTrashRdName(), self)

    def getInboxRdName(self):
        """ return redable name for inbox """

        return self.getDefaultFoldersNames()['INBOX'][1]

    def getInboxIMAPName(self):
        """ return IMAP name for inbox folder"""

        return  self.getDefaultFoldersNames()['INBOX'][0]

    def getSentMailRdName(self):
        """ return redable name for sent mail folder """

        return self.getDefaultFoldersNames()['sent-mail'][1]

    def getSentMailIMAPName(self):
        """ return IMAP name for sent mail folder"""

        return  self.getDefaultFoldersNames()['sent-mail'][0]

    def getDraftRdName(self):
        """ return redable name for draft folder """

        return self.getDefaultFoldersNames()['draft'][1]

    def getDraftIMAPName(self):
        """ return IMAP name for draft folder """

        return  self.getDefaultFoldersNames()['draft'][0]

    def getTrashRdName(self):
        """ return redable name for trash folder """

        return self.getDefaultFoldersNames()['trash'][1]

    def getTrashIMAPName(self):
        """ return IMAP name for trash folder """

        return  self.getDefaultFoldersNames()['trash'][0]


    def setDefaultFoldersNames(self, value={'INBOX':['INBOX','Inbox'],
                                      'sent-mail':['INBOX.sent-mail', 'Sent Mail'],
                                      'draft':['INBOX.brouillons', 'Draft'],
                                      'trash':['INBOX.Corbeille', 'Trash']}):
        """ set default folders """
        self.defaultFoldersNames=value


    def getIMAPFolders(self):
        """ return the liste of IMAP folders """

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        res=con.login(self.getIMAPLogin(), self.getIMAPPassword())

        imap_mailboxes=con.listFolders()

        prev_name=""

        res=[]
        for item in imap_mailboxes:
            readable_name=string.replace(item, "INBOX.", "")
            if string.find(item, "&") != (-1) :
                readable_name=string.replace(readable_name, "&AOk-", "")
                readable_name=string.replace(readable_name, "&AOA-", "")
                readable_name=string.replace(readable_name, "&AOI-", "")
                readable_name=string.replace(readable_name, "&AOg-", "")
                readable_name=string.replace(readable_name, "&-", "&")
                readable_name=string.replace(readable_name, "&AOc-", "")
                readable_name=string.replace(readable_name, "&APk-", "")
                readable_name=string.replace(readable_name, "&AOo-", "")
                readable_name=string.replace(readable_name, "&AOs-", "")
                readable_name=string.replace(readable_name, "&AO4-", "")
                readable_name=string.replace(readable_name, "&APQ-", "")
                readable_name=string.replace(readable_name, "&APM-", "")
                readable_name=string.replace(readable_name, "&APE-", "")
                readable_name=string.replace(readable_name, "&AOE-", "")
                readable_name=string.replace(readable_name, "&AMk-", "")
                
##            if readable_name=="INBOX" or readable_name=="inbox":
##                readable_name="Bote de rception"
##            if readable_name=="sent-mail":
##                readable_name="Elments envoys"
            if readable_name=="INBOX":
                readable_name=self.getInboxRdName()
            if  readable_name=="inbox":
                readable_name=self.getInboxRdName()
                if self.getInboxIMAPName() != 'inbox':
                    self.defaultFoldersNames['INBOX'][0]='inbox'
            if readable_name==self.getSentMailIMAPName():
                readable_name=self.getSentMailRdName()

            
            #res.append(IMAPFolder( item, readable_name, self))

            name=string.split(readable_name, '.')[0]
            if name==prev_name and not (name == '' or prev_name == ''):
                readable_name="  &nbsp; &nbsp; "+string.replace(readable_name, name, "")
            prev_name=name

            if not (name == '' or prev_name == ''):
                res.append(IMAPFolder( item, readable_name, self))


        # create default IMAP folder if not exist
        if not self.getSentMailIMAPName() in imap_mailboxes:
            con.connection.create(self.getSentMailIMAPName())
            res.append(IMAPFolder(self.getSentMailIMAPName(), self.getSentMailIMAPName(), self))
        if not self.getDraftIMAPName() in imap_mailboxes:
            con.connection.create(self.getDraftIMAPName())
            res.append(IMAPFolder(self.getDraftIMAPName(), self.getDraftIMAPName(), self))
        if not self.getTrashIMAPName() in imap_mailboxes:
            con.connection.create(self.getTrashIMAPName())
            res.append(IMAPFolder(self.getTrashIMAPName(), self.getTrashIMAPName(), self))
            
##        if not "INBOX.sent-mail" in imap_mailboxes:
##            con.connection.create("INBOX.sent-mail")
##            res.append(IMAPFolder( item, "Elments envoys", self))
##        if not "INBOX.brouillons" in imap_mailboxes:
##            con.connection.create("INBOX.brouillons")
##            res.append(IMAPFolder( item, "Brouillons", self))
##        if not "INBOX.Corbeille" in imap_mailboxes:
##            con.connection.create("INBOX.Corbeille")
##            res.append(IMAPFolder( item, "Corbeille", self))

        con.logout()

        return res


    def get_attachement(self, IMAPId, AttachId=1, IMAPName = "INBOX", REQUEST=None, RESPONSE=None, retour=1):
        """ return the attachement for download"""
        
        f = self.getFolder(IMAPName)   ## the folder
        m = f.getIMAPMessage(IMAPId)   ## the message

        #if attachment not rfc822 (mail message) type
        if string.find(AttachId, ".")==(-1):
            for a in m.getAttachements():
                if a.getId() == int(AttachId):
                    return a.download(REQUEST,RESPONSE)
            if retour:
                return self.view_message(IMAPName,IMAPId,REQUEST)

        #if attachment is rfc822 (mail message) type and contains attachments
        li=string.split(AttachId, ".")

        # attachment we want is in first level rfc822 maill attachment
        # li is [attachement level, attachment number from original level, attachemnt number]
        if li[0]=="1":
            for a in m.getAttachements():
                if a.getId() == (int(li[1])+1):
                    virtual_message=a.render_mail_attachment()
                    for a2 in virtual_message.getAttachements():
                        if a2.getId() == int(li[2]):
                            return a2.download(REQUEST,RESPONSE)

                        
        # attchment is in second level
        # li is [attachement level, attachment number from original level, , attachment number from first level, attachemnt number]
        if li[0]=="2":
            for a in m.getAttachements():
                if a.getId() == (int(li[1])+1):
                    virtual_message=a.render_mail_attachment()
                    for a2 in virtual_message.getAttachements():
                        if a2.getId() == (int(li[2])+1):
                             virtual_message2=a2.render_mail_attachment()
                             for a3 in virtual_message2.getAttachements(): 
                                 if a3.getId() == int(li[3]):
                                     return a3.download(REQUEST,RESPONSE)



    def getQuota(self):
        """ return % used quota on mailbox """

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        try:
            res=con.getQuota()
        except:
            res=-1
        con.logout()

        return res
        

    def deleteMessages(self, REQUEST=None):
        """ delete imap message on mail server"""

        if not REQUEST.has_key('IMAPIds'):
            return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)

        IMAPIds=REQUEST.IMAPIds
        
        if type(IMAPIds) is type(''):
                IMAPIds = [IMAPIds]

        if not REQUEST.has_key('start'):
            REQUEST.set('start', '0')

        if REQUEST.IMAPName:
            IMAPName=REQUEST.IMAPName
        else:
            IMAPName="INBOX"


        #copy = 1 if moving message to trash
        _copy=1

        quota=self.getQuota()
        
        if IMAPName==self.getTrashFolder().getImapName() or quota>999:
            _copy=0

        #copy=0 if delete message from trash or quota exceed for moving to rtash
        
        f=self.getFolder(IMAPName)
        f.moveIMAPMessages(folderdest="deleting", imapids=IMAPIds, copy=_copy)
        
        return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)
        

    def moveMessages(self, REQUEST=None):
        """ move messages from IMAP folder to another """

        if not REQUEST.has_key('IMAPIds'):
            return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)

        IMAPIds=REQUEST.IMAPIds
        
        if type(IMAPIds) is type(''):
                IMAPIds = [IMAPIds]

        if REQUEST.IMAPName:
            IMAPName=REQUEST.IMAPName
        else:
            IMAPName="INBOX"
            
        f=self.getFolder(IMAPName)
        
        f.moveIMAPMessages(folderdest=REQUEST.move_to_folder, imapids=IMAPIds)

        return REQUEST.response.redirect(self.absolute_url() + '/index_html?IMAPName=' +  quote(REQUEST.IMAPName) + '&start=' + REQUEST.start)


    def getPreviousAndNextMessagesIds(self, folderName, sortmail, IMAPId):
        """ return next IMAP id for sorted mails """

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        res=con.getPreviousAndNextMessagesIds(folderName=folderName, sortmail=sortmail, IMAPId=IMAPId)
        con.logout()
        return res

    def saveDraft(self, REQUEST):
        """ save message in draft Folder """

        listeAtt = []
        if (REQUEST.has_key('IMAPName') and REQUEST.has_key('IMAPId')):
            ##check if forwarded message or draft message with attachments
            try:
                f = self.getFolder(REQUEST['IMAPName'])   ## the folder
                m = f.getIMAPMessage(REQUEST['IMAPId'])   ## the message
                if REQUEST.has_key('forwarded_attachment'):
                    for a in m.getAttachements():
                        if str(a.getId()) in REQUEST['forwarded_attachment']:
                            listeAtt.append(a)      ## we append him to the list of attachements
            except:
                pass
            
        _to=[REQUEST.to]
        _cc=[REQUEST.cc]
        _bcc=[REQUEST.bcc]

        _headers={'subject':REQUEST.subject}

        ##### We add attachment
        for i in range(1,100):
            attKey = 'attFile%d' % i
            if REQUEST.has_key(attKey):
                if (type(REQUEST[attKey]) is not type('')) and (REQUEST[attKey].filename):
                    att = REQUEST[attKey]
                    filename = att.filename
                    data = att.read()
                    content_type = OFS.content_types.guess_content_type(
                        name=filename, body=data,
                        default='application/octet-stream')[0]
                    listeAtt.append(Attachement.Attachement(id=str(i),filename=filename,content_type=content_type,size=len(data),data=data))

                    
        message=IMAPMessage.IMAPMessage(expediteur=(self.getNomFrom(), self.getMailFrom()), subject=REQUEST.subject,
                            date="lundi", body=REQUEST.body,
                            destinataires={'to':_to, 'cc':_cc, 'bcc':_bcc},
                            attachements=listeAtt,
                            headers=_headers)

        message.headers['date'] =  self.ZopeTime().rfc822()
        
        message_brut=message.raw_message()
        message_brut=string.replace(message_brut, "\n", "\r\n")

        draft_folder=self.getDraftFolder().getImapName()

        con=self.getPasserelle()
        con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
        con.login(self.getIMAPLogin(), self.getIMAPPassword())
        draft_id=con.writeMessage(draft_folder, message_brut)
        try:
            con.setFlag(folderName=draft_folder, IMAPId=draft_id, flag="draft") 
        except:
            pass
        
        con.logout()

        return REQUEST.response.redirect(self.absolute_url() + '/index_html')


    def sendMail(self,to='',cc='',bcc='', subject = '[pas de sujet]', body = '' ,redirection_url='edit_message',REQUEST=None):
        """ send a mail """
        
        _to = [to]
        _cc = [cc]
        _bcc = [bcc]
        if REQUEST is None:
            REQUEST = self.REQUEST
        
        ImapName="INBOX"
        if REQUEST.has_key('IMAPName'):
            ImapName = REQUEST['IMAPName'] 
        st = '0'
        
        if REQUEST.has_key('start'):
            st = REQUEST['start']
        
        if to + cc + bcc == '':
            if redirection_url:
                return REQUEST.RESPONSE.redirect(REQUEST['URL1']+'/'+redirection_url+'?IMAPName='+ quote(ImapName) +'&start='+st+'&portal_status_message=Erreur%20message%20sans%20destinataire.')
            else:
                return
            
        ##### We add attachment
        listeAtt = []

        for i in range(1,100):
            attKey = 'attFile%d' % i
            if REQUEST.has_key(attKey):
                if type(REQUEST[attKey]) is not type('') and REQUEST[attKey].filename:
                   att = REQUEST[attKey]
                   if hasattr(att,'filename'):
		    filename = att.filename
                    try:
                        filename = string.split(filename,'\\')[-1]
                    except:
                        pass
                    
                    data = att.read()
                    content_type = OFS.content_types.guess_content_type(
                        name=filename, body=data,
                        default='application/octet-stream')[0]
                    listeAtt.append(Attachement.Attachement(id=str(i),filename=filename,content_type=content_type,size=len(data),data=data))
            

        ### add the attchement from the original message when forward or send from draft
        if (REQUEST.has_key('IMAPName') and REQUEST.has_key('IMAPId') and REQUEST.has_key('forward')) or (REQUEST.has_key('IMAPName') and REQUEST['IMAPName']==self.getDraftFolder().getImapName() and REQUEST.has_key('IMAPId')) :

            ## attForward is the list of attachement id to be forwarded
            f = self.getFolder(REQUEST['IMAPName'])   ## the folder
            m = f.getIMAPMessage(REQUEST['IMAPId'])   ## the message
            if REQUEST.has_key('forwarded_attachment'):
                for a in m.getAttachements():
                    if str(a.getId()) in REQUEST['forwarded_attachment']:
                        listeAtt.append(a)


	_headers={'subject':subject, 'date':self.ZopeTime().rfc822()}
        message=IMAPMessage.IMAPMessage(expediteur=(self.getNomFrom(), self.getMailFrom()),
                                        subject=subject,
                                        date="lundi",
                                        body=body,
                                        destinataires={'to':_to, 'cc':_cc, 'bcc':_bcc},
                                        attachements=listeAtt,     
                                        headers=_headers)
        raw_message = message.raw_message()
        
        if REQUEST.has_key('autoSaveSentMessage') and REQUEST.autoSaveSentMessage == "oui":       
            #copy to sent-mail on server
            message_brut=string.replace(raw_message, "\n", "\r\n")
           
            con=self.getPasserelle()
            con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
            con.login(self.getIMAPLogin(), self.getIMAPPassword())
            con.writeMessage(folderName=self.getSentMailFolder().getImapName(), raw_message=message_brut)
            con.logout()
                    
        erreur=1

        try:
            smtp_connection = smtplib.SMTP(self.getSMTPServer())
            _recipients=[]
            for item in ['to', 'cc', 'bcc']:
                for address in message.destinataires[item]:
                    spl=","
                    if string.find(address, ",")!=-1:
                        spl=","
                    else:
                        spl=";"
                    for people in string.split(address, spl):
                        peop=string.strip(people)
			if string.find(peop, "@")==-1 and (len(peop)>2):
				peop=peop+"@"+self.getDomain()
                        if len(peop) > 2:
                            _recipients.append(peop)

            mailfrom = string.replace(self.getNomFrom(),'.','-')+' <' + self.getMailFrom()+ '>'
            smtp_connection.sendmail(mailfrom, _recipients, raw_message)
            smtp_connection.quit()
    
        except:
            erreur=2
        
        if erreur == 2:
            if redirection_url:
                REQUEST.set('IMAPName',quote(ImapName))
                REQUEST.set('start',st)
                REQUEST.set('error_message',"Une erreur est survenue, votre message n'a pas pu etre envoye, veulliez retentez d'envoyer ce message")
                destinat = {'to':string.join(message.destinataires['to'],','), 'cc':string.join(message.destinataires['cc'],','), 'bcc':string.join(message.destinataires['bcc'],',')}
                return self.edit_message(subject=subject, body=body, destinataires=destinat,attachements=listeAtt,REQUEST=REQUEST)
                #return REQUEST.RESPONSE.redirect(REQUEST['URL1']+'/'+redirection_url+'?IMAPName='+ quote(ImapName) +'&start='+st+'&sendfails=1')
        else:
            if REQUEST.has_key('IMAPName') and REQUEST.has_key('IMAPId') and REQUEST.has_key('reply'):
                con=self.getPasserelle()
                con.connect(self, server=self.getIMAPServer(), port=self.getIMAPPort())
                con.login(self.getIMAPLogin(), self.getIMAPPassword())
                con.setFlag(folderName=REQUEST['IMAPName'], IMAPId=REQUEST['IMAPId'], flag="anwser")
                con.logout()
            if redirection_url:    
                return REQUEST.RESPONSE.redirect(self.absolute_url() + '/index_html?IMAPName=' + quote(ImapName) + '&start=' + st)



    def processId(self,filename):
        id=''
        # Generate valid  Zope id
        id=filename
        id=id[max(
            string.rfind(id,'/'), 
            string.rfind(id,'\\'), 
            string.rfind(id,':')
            )+1:]
        id=string.replace(id,' ','_')
        id=string.replace(id,'(','_')
        id=string.replace(id,')','_')
        id=string.replace(id,'%','_')
        id=string.replace(id,'!','_')
        id=string.replace(id,'&','_')
        id=string.replace(id,'?','_')
        id=string.replace(id,'','e')
        id=string.replace(id,'','e')
        id=string.replace(id,'','e')
        id=string.replace(id,'','a')
        id=string.replace(id,'','a')
        id=string.replace(id,'','u')
        id=string.replace(id,'','i')
        id=string.replace(id,'','i')
        id=string.replace(id,'','u')
        id=string.replace(id,'','u')
        id=string.replace(id,'','o')
        id=string.replace(id,"'",'_')
        if id:
            return id
        else:
            return None


    def setNomAttachementWithInt(self,nomFichier,ind):
        """ Rajoute un indice a noFichier pour ne pas avoir d'erreur lors de setObject (attachement.txt ==> attachement_2.txt) """
        data = string.split (nomFichier,'.')
        nomCourt =data[0]
        if nomCourt[-2:]=='_' + str(ind):
            nomCourt = nomCourt[:-1] +str(ind+1) 
        else:
            nomCourt = nomCourt + '_' + str(ind)
        data[0]= nomCourt
        res = string.join(data,'.')
        return res



    def move_attachement_to_cartable(self, idsattach=[], REQUEST=None, RESPONSE=None):
        """Wrapper around manage_copyObjects, avoids management interface"""

        if not idsattach:
            try:
                return RESPONSE.redirect(self.absolute_url()+"/view_message?portal_status_message=Erreur%20Aucun%20attachement%20slectionn&IMAPId="+ REQUEST['IMAPId'] + "&sortmail="+REQUEST.sortmail+"&start="+REQUEST.start +"&IMAPName="+ quote(REQUEST.IMAPName))
            except:
                return RESPONSE.redirect(self.absolute_url()+"/view_message?portal_status_message=Erreur%20Aucun%20attachement%20slectionn&IMAPId="+ REQUEST['IMAPId']+"&sortmail="+REQUEST.sortmail[0]+"&start="+REQUEST.start[0] +"&IMAPName="+ quote(REQUEST.IMAPName))

        ref=self.aq_parent
        if type(idsattach) is type(''):
            idsattach = [idsattach]
        for id in idsattach:
            try:
                imap_name , imap_id , attach_id , attach_filename , attach_content_type = string.split(id,'9:o')
            except:
                imap_name , imap_id , attach_id , attach_filename  = string.split(id,'9:o')
                attach_content_type="type"

            ## IMAPId, AttachId=1, IMAPName 
            item = self.get_attachement(imap_id,attach_id,imap_name,REQUEST,RESPONSE,retour=0)            
            #item = getattr(self,id)
            nomFichier = self.processId(attach_filename)
            nomFichierTmp = nomFichier
            ind = 1
            while nomFichierTmp in ref.objectIds():
                ind = ind + 1
                nomFichierTmp = self.setNomAttachementWithInt(nomFichier,ind)
            nomFichier = nomFichierTmp

            if attach_content_type[:6]=='image/':
                try:
                    from Products.PTKBase.PortalExtImage import manage_addPortalExtImage
                    manage_addPortalExtImage(ref,fn=nomFichier,title='', descr='', file=cStringIO.StringIO(item), preview='', content_type=attach_content_type, create_prev=1, maxx='256', maxy='256',ratio=1, permission_check=0)
                except:
                    ref.manage_addImage(nomFichier,file=cStringIO.StringIO(item),title=nomFichier,precondition='', content_type=attach_content_type)
                    
            else:
                try:
                    from Products.PTKBase.PortalExtFile import manage_addPortalExtFile
                    manage_addPortalExtFile(ref,fn=nomFichier,title='',descr='',file=cStringIO.StringIO(item),content_type=attach_content_type)
                except:
                    ref.manage_addFile(nomFichier,file=cStringIO.StringIO(item),title=nomFichier,precondition='', content_type=attach_content_type)
                    

        try:
            go="/view_message?IMAPName="+ quote(imap_name) +"&IMAPId="+imap_id+"&start="+ REQUEST.start+"&portal_status_message=Dpos%20dans%20le%20cartable"
        except:
            go="/view_message?IMAPName="+ quote(imap_name)+"&IMAPId="+imap_id+"&start="+ REQUEST.start[0]+"&portal_status_message=Dpos%20dans%20le%20cartable" 

        return RESPONSE.redirect(self.absolute_url()+go)

    def compose_direct_mail_with_attachment(self, conteneur, ids=None, destinataires=[], body='', REQUEST=None, RESPONSE=None):
        """ compose mail with cartable item """
        erreur = 0
        if body:
            subject = body[0:30]
        else:
            subject = "document(s) de mon cartable"

        mailable = []
        unmailable=[]

        listeObject = map( (lambda x, conteneur = conteneur : getattr(conteneur,x )),filter(lambda x, ids = ids : x in ids , conteneur.objectIds()))

        for obj in listeObject:
            if obj.isPrincipiaFolderish:
                listeObject = listeObject + obj.objectValues()
        nombreObjets = len(listeObject)

        for obj in listeObject:
            if obj.meta_type not in ['Image','Fichier','Link','Nouvelle','Document']:
                unmailable.append(obj.id)
                listeObject.remove(obj)
        if not listeObject:
            return [], unmailable

        # Formatage Expediteur
        sender = (self.getNomFrom(),self.getMailFrom())
        
        # Les Headers
        _headers={'subject':subject, 'date':self.ZopeTime().rfc822()}

        # La Liste des attachements pour la creation de l'objet IMAPMessage
        listeAtt = []
        i = 0
        for obj in listeObject:
            filename = ''
            content_type = ''
            data = ''
            try:
                if hasattr(obj,'title') and obj.title:
                    filename = obj.title
                else:
                    filename = obj.id
                if obj.meta_type=='Link':
                    content_type='text/plain'
                    data = obj.title + ' : ' + obj.remote_url + '\n' + obj.text + '\n\n'
                elif obj.meta_type=='Nouvelle':
                    content_type='text/plain'
                    data =  obj.title + ' : ' + obj.description + '\n' + obj.text + '\n\n'
                elif obj.meta_type=='Document':
                    if obj.text_format in ["structured-text","plaintext"]:
                        content_type='text/plain'
                    else:
                        content_type='text/html'
                    data = obj.text
                    if string.find(filename,'.')==-1:
                        filename = filename + '.txt'
                elif obj.meta_type=='Image' or obj.meta_type=='Fichier':
                    content_type=obj.content_type
                    data = obj.getRawData()
                if filename and content_type and data:
                    i=i+1
                    listeAtt.append(Attachement.Attachement(id=str(i),filename=filename,content_type=content_type,size=len(data),data=data))     
                    mailable.append(obj.id)
                else:
                    unmailable.append(obj.id)
            except:
                unmailable.append(obj.id)
                pass
                # "erreur du type de fichier / dossier"

        message=IMAPMessage.IMAPMessage(expediteur = sender,
                                        subject = subject,
                                        date = _headers['date'],
                                        body = body + "\n\n--\n" + self.getSignature() ,
                                        destinataires = {'to': destinataires,'cc':[],'bcc':[] },
                                        attachements = listeAtt,     
                                        headers = _headers)
        raw_message = message.raw_message()
        
        smtp_connection = smtplib.SMTP(self.getSMTPServer())
        try:
            smtp_connection.sendmail(sender[0] + ' <'+ sender[1] + '>',message.destinataires['to'], raw_message)
        except:
            erreur=2
        smtp_connection.quit()

        return mailable,unmailable


    def add_to_addressbook(self,name=' ',email=' ',IMAPName='',IMAPId='',start='',REQUEST=None):
        """ find and add to addressBook """

        if REQUEST.has_key('mailBookMail'):
            new_contact = string.replace(REQUEST.mailBookName, ",", " ")+","+string.replace(REQUEST.mailBookMail, ", ", " ")
            self.adPeopleMailBook(new_contact=new_contact)
        else:
            addressbook = self.searchAddressBook()
            addressbook.addABContactExterieur(nom=name,email=email)
        
        if REQUEST is not None:
            REQUEST.RESPONSE.redirect(self.absolute_url()+'/view_message?IMAPName='+ quote(IMAPName) +'&IMAPId='+IMAPId+'&start='+start+'&contactAdded=1')

    def PutBodyInCartable(self, body='', subject='', REQUEST=None, RESPONSE=None):
        """Put a body message in your cartable"""
        titlep = self.processId(subject)
        ref=self.aq_parent
        id = str(DateTime.DateTime().millis())
        
        try:
            from Products.PTKBase.PortalExtFile import manage_addPortalExtFile
            manage_addPortalExtFile(ref,fn=id,title=titlep,descr='',file=cStringIO.StringIO(body),content_type='text/html')
        except:
            ref.manage_addFile(id,file=cStringIO.StringIO(body),title=titlep,precondition='', content_type='text/html')
                
        return REQUEST.RESPONSE.redirect(self.absolute_url()+'/index_html?portal_status_message=Depose%20dans%20cartable%20reussie')
       
    

    ##########  Methodes a refaire

    def page_navigation_menu(self, start="0", folder_id=None, nb_messages_in_mailbox=1):
            """ return the navigation page for batching messages list"""

            menu=""                        #### Le string contenant le menu resultat

            start=int(start)

            folder_id=quote(folder_id)
            
            # Nombre de mail par page
            listingSize=int(self.listingSize)
            
            # Nombre totale de mail dans la boite
            try:
                nbMessages = int(nb_messages_in_mailbox)
            except:
                return menu
            if not nbMessages:
                return menu
            
            # Taille d'un tranche de page
            tailleFixeNbPage = 10
            
            # Nombre de pages total
            nbPages, reste = divmod(nbMessages, listingSize)
            if reste:
                nbPages += 1
            
            # Nombre de Tranche total
            nTrancheMax, reste2 = divmod(nbPages, tailleFixeNbPage)
            if reste2:
                nTrancheMax += 1
            
            # Numero de page en fonction du start
            e, f = divmod(start, listingSize) 
            noPage = e + 1
            
            # Numero de la tranche
            np, reste3 = divmod(noPage, tailleFixeNbPage)
            if reste3:
                np += 1
            
            # Calcul de la borne infieur et superieur de la tranche np    
            if np != nTrancheMax:
                sup = tailleFixeNbPage * np
                inf = sup - (tailleFixeNbPage - 1)
            else:
                sup = nbPages
                inf = tailleFixeNbPage * np - (tailleFixeNbPage - 1)
            
            # les << de l'affichage
            if start >= 1:
                prec = start - listingSize
                menu += " <a href='%s/index_html?IMAPName=%s&start=%d' class=\"navigation\">%s</a> " % (self.absolute_url(), folder_id, prec, " &laquo;&laquo; ")
            
            # Construction de la tranche
            for indice in range(inf, sup + 1):
                newstart = (indice - 1) * listingSize
        
                if indice == noPage:
                    # La page ou on est
                    menu += " <a href='%s/index_html?IMAPName=%s&start=%d' class=\"hotnavigation\">%d</a> " % (self.absolute_url(), folder_id, newstart, indice)
                else:
                    # les autres pages
                    menu += " <a href='%s/index_html?IMAPName=%s&start=%d' class=\"navigation\">%d</a> " % (self.absolute_url(), folder_id, newstart, indice)
            
            # les >> de l'affichage
            sup2, mod = divmod(nbMessages, listingSize)
            if not mod:
                sup2 = sup2 - 1
            
            if start >= (sup2*listingSize) :
                return menu
            else:
                suiv = start + listingSize
                menu += " <a href='%s/index_html?IMAPName=%s&start=%d' class=\"navigation\">%s</a> " % (self.absolute_url(), folder_id, suiv, " &raquo;&raquo; ")
            return menu   
            

    def __bobo_traverse__(self, REQUEST, name):
        """ redifined method for get attachment name when download """

        try:
            if hasattr(self,name) and not REQUEST.has_key('AttachId'):
                return getattr(self,name)
        except AttributeError:
            pass
        try:
            if REQUEST.has_key('AttachId'):
                return self.get_attachement
        except:
            pass
        REQUEST.RESPONSE.notFoundError("%s\n" % (name))
